import { DeleteUserCommand } from '@modules/user/core/application/commands/delete-user/delete-user.command';
import { DeleteUserService } from '@modules/user/core/application/commands/delete-user/delete-user.service';
import { DeleteUserRequestDto } from '@modules/user/interface/grpc-controllers/dtos/delete-user.request.dto';
import { USER_REPOSITORY } from '@modules/user/user.di-tokens';
import { Test, TestingModule } from '@nestjs/testing';

const deleteUserRequest: DeleteUserRequestDto = {
  id: '165192d4-398a-4469-a16b-98c02cc6f531',
};

const mockUserEntity = {
  delete: jest.fn(),
};

const mockUserRepository = {
  findOneById: jest.fn().mockImplementation(() => mockUserEntity),
  delete: jest.fn().mockImplementationOnce(() => true),
};

describe('Delete User Service', () => {
  let deleteUserService: DeleteUserService;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        {
          provide: USER_REPOSITORY,
          useValue: mockUserRepository,
        },
        DeleteUserService,
      ],
    }).compile();

    deleteUserService = module.get<DeleteUserService>(DeleteUserService);
  });

  it('should be defined', () => {
    expect(deleteUserService).toBeDefined();
  });

  describe('execution', () => {
    const deleteUserCommand = new DeleteUserCommand(deleteUserRequest);
    it('should delete a user', async () => {
      const result: boolean =
        await deleteUserService.execute(deleteUserCommand);
      expect(result).toBeTruthy();
    });
  });
});
